Debian Bug report logs - #510358
zsh: please allow use as /bin/sh

version graph

Package: zsh; Maintainer for zsh is Debian Zsh Maintainers <pkg-zsh-devel@lists.alioth.debian.org>; Source for zsh is src:zsh.

Reported by: "brian m. carlson" <sandals@crustytoothpaste.net>

Date: Wed, 31 Dec 2008 21:48:04 UTC

Severity: wishlist

Tags: wontfix

Found in version zsh/4.3.9-1

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Wed, 31 Dec 2008 21:48:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to "brian m. carlson" <sandals@crustytoothpaste.ath.cx>:
New Bug report received and forwarded. Copy sent to Clint Adams <schizo@debian.org>. (Wed, 31 Dec 2008 21:48:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: zsh: please allow use as /bin/sh
Date: Wed, 31 Dec 2008 21:41:27 +0000
[Message part 1 (text/plain, inline)]
Package: zsh
Version: 4.3.9-1
Severity: wishlist

It would be very nice if zsh could be used as /bin/sh.  Several other
shells offer this capability, and I'd like to see zsh added to the list.

-- System Information:
Debian Release: 5.0
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.27-1-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8) (ignored: LC_ALL set to en_US.UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages zsh depends on:
ii  libc6                     2.8+20080809-3 GNU C Library: Shared libraries
ii  libcap2                   2.11-2         support for getting/setting POSIX.
ii  libncursesw5              5.7+20081220-1 shared libraries for terminal hand

Versions of packages zsh recommends:
ii  libpcre3                      7.8-2      Perl 5 Compatible Regular Expressi

Versions of packages zsh suggests:
pn  zsh-doc                       <none>     (no description available)

-- no debconf information

-- 
brian m. carlson / brian with sandals: Houston, Texas, US
+1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
troff on top of XML: http://crustytoothpaste.ath.cx/~bmc/code/thwack
OpenPGP: RSA v4 4096b 88AC E9B2 9196 305B A994 7552 F1BA 225C 0223 B187
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Thu, 01 Jan 2009 21:00:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Richard Hartmann" <richih.mailinglist@gmail.com>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Thu, 01 Jan 2009 21:00:06 GMT) Full text and rfc822 format available.

Message #10 received at 510358@bugs.debian.org (full text, mbox):

From: "Richard Hartmann" <richih.mailinglist@gmail.com>
To: 510358@bugs.debian.org, sandals@crustytoothpaste.ath.cx
Subject: Need more info
Date: Thu, 1 Jan 2009 21:44:34 +0100
Hi Brian,

I am not sure to what list you are referring to as /bin/sh
is not using the normal /etc/alternatives system -- Can
you provide more info, please?


Richard




Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Thu, 01 Jan 2009 21:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to "brian m. carlson" <sandals@crustytoothpaste.ath.cx>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Thu, 01 Jan 2009 21:03:07 GMT) Full text and rfc822 format available.

Message #15 received at 510358@bugs.debian.org (full text, mbox):

From: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
To: Richard Hartmann <richih.mailinglist@gmail.com>
Cc: 510358@bugs.debian.org
Subject: Re: Need more info
Date: Thu, 1 Jan 2009 21:00:32 +0000
[Message part 1 (text/plain, inline)]
On Thu, Jan 01, 2009 at 09:44:34PM +0100, Richard Hartmann wrote:
>Hi Brian,
>
>I am not sure to what list you are referring to as /bin/sh
>is not using the normal /etc/alternatives system -- Can
>you provide more info, please?

There isn't a list per se; I was using that term metaphorically.  dash,
posh, ksh, mksh, and pdksh all have support for diverting /bin/sh to
their respective shells.  I'd like zsh to add that support.

Obviously, the best solution is to make all the shells use the
alternatives mechanism, but I think that may be impossible since /bin/sh
is so essential to the system that dpkg (which provides
update-alternatives) may not be able to be installed unless there is a
working /bin/sh.  Major props if you can get it to work.

-- 
brian m. carlson / brian with sandals: Houston, Texas, US
+1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
troff on top of XML: http://crustytoothpaste.ath.cx/~bmc/code/thwack
OpenPGP: RSA v4 4096b 88AC E9B2 9196 305B A994 7552 F1BA 225C 0223 B187
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Thu, 01 Jan 2009 21:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Richard Hartmann" <richih.mailinglist@gmail.com>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Thu, 01 Jan 2009 21:27:03 GMT) Full text and rfc822 format available.

Message #20 received at 510358@bugs.debian.org (full text, mbox):

From: "Richard Hartmann" <richih.mailinglist@gmail.com>
To: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
Cc: 510358@bugs.debian.org
Subject: Re: Need more info
Date: Thu, 1 Jan 2009 22:25:12 +0100
On Thu, Jan 1, 2009 at 22:00, brian m. carlson
<sandals@crustytoothpaste.ath.cx> wrote:

> There isn't a list per se; I was using that term metaphorically.  dash,
> posh, ksh, mksh, and pdksh all have support for diverting /bin/sh to
> their respective shells.  I'd like zsh to add that support.

What kind of support are you looking for? Calling zsh as sh will put
it into compatible mode, so bending the symlink is no problem.


> Obviously, the best solution is to make all the shells use the
> alternatives mechanism, but I think that may be impossible since /bin/sh
> is so essential to the system that dpkg (which provides
> update-alternatives) may not be able to be installed unless there is a
> working /bin/sh.  Major props if you can get it to work.

That is something for debian-devel@ldo, not for us :p

Wanna write a proposal?


Richard




Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Thu, 01 Jan 2009 21:45:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "brian m. carlson" <sandals@crustytoothpaste.ath.cx>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Thu, 01 Jan 2009 21:45:02 GMT) Full text and rfc822 format available.

Message #25 received at 510358@bugs.debian.org (full text, mbox):

From: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
To: Richard Hartmann <richih.mailinglist@gmail.com>
Cc: 510358@bugs.debian.org
Subject: Re: Need more info
Date: Thu, 1 Jan 2009 21:41:33 +0000
[Message part 1 (text/plain, inline)]
On Thu, Jan 01, 2009 at 10:25:12PM +0100, Richard Hartmann wrote:
>On Thu, Jan 1, 2009 at 22:00, brian m. carlson
><sandals@crustytoothpaste.ath.cx> wrote:
>
>> There isn't a list per se; I was using that term metaphorically.  dash,
>> posh, ksh, mksh, and pdksh all have support for diverting /bin/sh to
>> their respective shells.  I'd like zsh to add that support.
>
>What kind of support are you looking for? Calling zsh as sh will put
>it into compatible mode, so bending the symlink is no problem.

I want the zsh package to ask me if it should divert /bin/sh, like the
other shells do.  In other words, I want zsh to be supported as
/bin/sh; if there is a bug with /bin/sh compatibility, that that bug
will be taken seriously.

>Wanna write a proposal?

I may at some point.  I suspect it will be technically difficult,
though.

-- 
brian m. carlson / brian with sandals: Houston, Texas, US
+1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
troff on top of XML: http://crustytoothpaste.ath.cx/~bmc/code/thwack
OpenPGP: RSA v4 4096b 88AC E9B2 9196 305B A994 7552 F1BA 225C 0223 B187
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Thu, 01 Jan 2009 21:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Richard Hartmann" <richih.mailinglist@gmail.com>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Thu, 01 Jan 2009 21:51:03 GMT) Full text and rfc822 format available.

Message #30 received at 510358@bugs.debian.org (full text, mbox):

From: "Richard Hartmann" <richih.mailinglist@gmail.com>
To: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
Cc: 510358@bugs.debian.org
Subject: Re: Need more info
Date: Thu, 1 Jan 2009 22:49:35 +0100
On Thu, Jan 1, 2009 at 22:41, brian m. carlson
<sandals@crustytoothpaste.ath.cx> wrote:

> I want the zsh package to ask me if it should divert /bin/sh, like the
> other shells do.  In other words, I want zsh to be supported as
> /bin/sh; if there is a bug with /bin/sh compatibility, that that bug
> will be taken seriously.

During my bug triage, I have installed pretty much all shells I could
find. None of them asked me if I wanted to bend /bin/sh to them.

What level of questions did you set dpkg to ask you?


Richard




Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Thu, 01 Jan 2009 22:00:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "brian m. carlson" <sandals@crustytoothpaste.ath.cx>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Thu, 01 Jan 2009 22:00:02 GMT) Full text and rfc822 format available.

Message #35 received at 510358@bugs.debian.org (full text, mbox):

From: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
To: Richard Hartmann <richih.mailinglist@gmail.com>
Cc: 510358@bugs.debian.org
Subject: Re: Need more info
Date: Thu, 1 Jan 2009 21:56:53 +0000
[Message part 1 (text/plain, inline)]
On Thu, Jan 01, 2009 at 10:49:35PM +0100, Richard Hartmann wrote:
>On Thu, Jan 1, 2009 at 22:41, brian m. carlson
><sandals@crustytoothpaste.ath.cx> wrote:
>
>> I want the zsh package to ask me if it should divert /bin/sh, like the
>> other shells do.  In other words, I want zsh to be supported as
>> /bin/sh; if there is a bug with /bin/sh compatibility, that that bug
>> will be taken seriously.
>
>During my bug triage, I have installed pretty much all shells I could
>find. None of them asked me if I wanted to bend /bin/sh to them.

Okay, I just checked, and dash, posh, and mksh all ask.  pdksh and ksh
don't seem to ask like I thought they did.  I would like zsh to ask.

>What level of questions did you set dpkg to ask you?

Low.  Try dpkg-reconfigure, which will ask every question, regardless of
priority.

-- 
brian m. carlson / brian with sandals: Houston, Texas, US
+1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
troff on top of XML: http://crustytoothpaste.ath.cx/~bmc/code/thwack
OpenPGP: RSA v4 4096b 88AC E9B2 9196 305B A994 7552 F1BA 225C 0223 B187
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Thu, 01 Jan 2009 22:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Richard Hartmann" <richih.mailinglist@gmail.com>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Thu, 01 Jan 2009 22:03:02 GMT) Full text and rfc822 format available.

Message #40 received at 510358@bugs.debian.org (full text, mbox):

From: "Richard Hartmann" <richih.mailinglist@gmail.com>
To: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>, "Clint Adams" <schizo@debian.org>
Cc: 510358@bugs.debian.org
Subject: Re: Need more info
Date: Thu, 1 Jan 2009 23:00:43 +0100
On Thu, Jan 1, 2009 at 22:56, brian m. carlson
<sandals@crustytoothpaste.ath.cx> wrote:
> On Thu, Jan 01, 2009 at 10:49:35PM +0100, Richard Hartmann wrote:
>>
>> On Thu, Jan 1, 2009 at 22:41, brian m. carlson
>> <sandals@crustytoothpaste.ath.cx> wrote:
>>
>>> I want the zsh package to ask me if it should divert /bin/sh, like the
>>> other shells do.  In other words, I want zsh to be supported as
>>> /bin/sh; if there is a bug with /bin/sh compatibility, that that bug
>>> will be taken seriously.
>>
>> During my bug triage, I have installed pretty much all shells I could
>> find. None of them asked me if I wanted to bend /bin/sh to them.
>
> Okay, I just checked, and dash, posh, and mksh all ask.  pdksh and ksh
> don't seem to ask like I thought they did.  I would like zsh to ask.

Clint, what is your take on this? Do we want to ask this question with
a low priority? I don't know how I feel about touching something as
important as this manually.


> Low.  Try dpkg-reconfigure, which will ask every question, regardless of
> priority.

Yah, I know. I just wanted to know which level you use. Thanks,
though :)


Richard




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#510358; Package zsh. (Fri, 02 Jan 2009 15:11:31 GMT) Full text and rfc822 format available.

Acknowledgement sent to Clint Adams <schizo@debian.org>:
Extra info received and forwarded to list. (Fri, 02 Jan 2009 15:11:58 GMT) Full text and rfc822 format available.

Message #45 received at 510358@bugs.debian.org (full text, mbox):

From: Clint Adams <schizo@debian.org>
To: Richard Hartmann <richih.mailinglist@gmail.com>
Cc: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>, 510358@bugs.debian.org
Subject: Re: Need more info
Date: Fri, 2 Jan 2009 15:03:29 +0000
On Thu, Jan 01, 2009 at 11:00:43PM +0100, Richard Hartmann wrote:
> Clint, what is your take on this? Do we want to ask this question with
> a low priority? I don't know how I feel about touching something as
> important as this manually.

In the past, there was at least one incompatibility (that could have
been worked around with a shell function).  I don't know how suitable
zsh is as a Debian /bin/sh right now, and I'm not sure we want to
support that (the only compelling benefit I could see is having zsh
be the only shell on your system, which is currently impossible anyway).

Brian, are you using zsh as /bin/sh already, with a manual symlink change?
If so, have you run into any problems?

If we do want to do this, it will reintroduce a dependency on debconf
(which is not a very big deal).




Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Fri, 02 Jan 2009 15:30:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "brian m. carlson" <sandals@crustytoothpaste.ath.cx>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Fri, 02 Jan 2009 15:30:02 GMT) Full text and rfc822 format available.

Message #50 received at 510358@bugs.debian.org (full text, mbox):

From: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
To: Clint Adams <schizo@debian.org>
Cc: Richard Hartmann <richih.mailinglist@gmail.com>, 510358@bugs.debian.org
Subject: Re: Need more info
Date: Fri, 2 Jan 2009 15:29:21 +0000
[Message part 1 (text/plain, inline)]
On Fri, Jan 02, 2009 at 03:03:29PM +0000, Clint Adams wrote:
>On Thu, Jan 01, 2009 at 11:00:43PM +0100, Richard Hartmann wrote:
>> Clint, what is your take on this? Do we want to ask this question with
>> a low priority? I don't know how I feel about touching something as
>> important as this manually.
>
>In the past, there was at least one incompatibility (that could have
>been worked around with a shell function).  I don't know how suitable
>zsh is as a Debian /bin/sh right now, and I'm not sure we want to
>support that (the only compelling benefit I could see is having zsh
>be the only shell on your system, which is currently impossible anyway).

That's why I filed it as a wishlist bug.  If there are known
incompatibilities, you might want to block this bug with the appropriate
bug numbers.

>Brian, are you using zsh as /bin/sh already, with a manual symlink change?
>If so, have you run into any problems?

No, I'm not.  I understand that grml (a live CD distribution based on
Debian) set zsh as /bin/sh for some time, and did find a few bugs.  See
<http://grml.org/faq/#zsh_binsh>.  Mac OS X used to do it as well.

I just performed the symlink change and I'll let you know what does and
doesn't work.  I'll certainly file wishlist bugs if I encounter any
problems.

-- 
brian m. carlson / brian with sandals: Houston, Texas, US
+1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
troff on top of XML: http://crustytoothpaste.ath.cx/~bmc/code/thwack
OpenPGP: RSA v4 4096b 88AC E9B2 9196 305B A994 7552 F1BA 225C 0223 B187
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Fri, 02 Jan 2009 16:00:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Richard Hartmann" <richih.mailinglist@gmail.com>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Fri, 02 Jan 2009 16:00:02 GMT) Full text and rfc822 format available.

Message #55 received at 510358@bugs.debian.org (full text, mbox):

From: "Richard Hartmann" <richih.mailinglist@gmail.com>
To: "Clint Adams" <schizo@debian.org>
Cc: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>, 510358@bugs.debian.org
Subject: Re: Need more info
Date: Fri, 2 Jan 2009 16:57:34 +0100
On Fri, Jan 2, 2009 at 16:03, Clint Adams <schizo@debian.org> wrote:


> Brian, are you using zsh as /bin/sh already, with a manual symlink change?
> If so, have you run into any problems?

I did run such a setup for some months a year or two ago. Long story short,
you need to fix lots of stuff that breaks, especially during package
installation.


The dash initiative will have made this situation a lot better, but I did not
try, since then. Call me a burnt child ;)


Richard

PS: I should have mentioned that in my first mail, sorry..




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#510358; Package zsh. (Fri, 02 Jan 2009 16:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Clint Adams <schizo@debian.org>:
Extra info received and forwarded to list. (Fri, 02 Jan 2009 16:00:03 GMT) Full text and rfc822 format available.

Message #60 received at 510358@bugs.debian.org (full text, mbox):

From: Clint Adams <schizo@debian.org>
To: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>, 510358@bugs.debian.org
Cc: Richard Hartmann <richih.mailinglist@gmail.com>
Subject: Re: Bug#510358: Need more info
Date: Fri, 2 Jan 2009 15:59:20 +0000
On Fri, Jan 02, 2009 at 03:29:21PM +0000, brian m. carlson wrote:
> That's why I filed it as a wishlist bug.  If there are known
> incompatibilities, you might want to block this bug with the appropriate
> bug numbers.

Anything I can remember has since been fixed, except for "jobs -p", which
may never be.  Admittedly that one shouldn't ever matter.

> I just performed the symlink change and I'll let you know what does and
> doesn't work.  I'll certainly file wishlist bugs if I encounter any
> problems.

Great.  Also, why?




Information forwarded to debian-bugs-dist@lists.debian.org, Clint Adams <schizo@debian.org>:
Bug#510358; Package zsh. (Fri, 02 Jan 2009 16:00:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Richard Hartmann" <richih.mailinglist@gmail.com>:
Extra info received and forwarded to list. Copy sent to Clint Adams <schizo@debian.org>. (Fri, 02 Jan 2009 16:00:05 GMT) Full text and rfc822 format available.

Message #65 received at 510358@bugs.debian.org (full text, mbox):

From: "Richard Hartmann" <richih.mailinglist@gmail.com>
To: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
Cc: "Clint Adams" <schizo@debian.org>, 510358@bugs.debian.org
Subject: Re: Need more info
Date: Fri, 2 Jan 2009 16:59:38 +0100
On Fri, Jan 2, 2009 at 16:29, brian m. carlson
<sandals@crustytoothpaste.ath.cx> wrote:

> I just performed the symlink change and I'll let you know what does and
> doesn't work.  I'll certainly file wishlist bugs if I encounter any
> problems.

If you run into problems, try it with dash, as well.

If if works then, file against Zsh with prio normal.
If it does _not_ work after that, file against the package containing the
script. If it's a preinstall etc script, I think you need to file as grave, but
I could be wrong on that.


RIchard




Changed Bug submitter to '"brian m. carlson" <sandals@crustytoothpaste.net>' from '"brian m. carlson" <sandals@crustytoothpaste.ath.cx>' Request was from "brian m. carlson" <sandals@crustytoothpaste.net> to control@bugs.debian.org. (Thu, 03 Feb 2011 20:51:33 GMT) Full text and rfc822 format available.

Added tag(s) wontfix. Request was from Axel Beckert <abe@debian.org> to control@bugs.debian.org. (Thu, 05 Dec 2013 02:57:04 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 00:18:17 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.